aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ipq40xx/base-files
diff options
context:
space:
mode:
authorOever González <notengobattery@gmail.com>2019-01-23 21:20:55 -0600
committerChristian Lamparter <chunkeey@gmail.com>2019-01-26 21:43:11 +0100
commita873b292840848b67addb5be0c762d292bde33a1 (patch)
treedf1a7df9fa65caa736df8c5bc2e43086a67b85bb /target/linux/ipq40xx/base-files
parent892d741259ae1f8c4b18ba8ae26c7f85f83f6340 (diff)
downloadupstream-a873b292840848b67addb5be0c762d292bde33a1.tar.gz
upstream-a873b292840848b67addb5be0c762d292bde33a1.tar.bz2
upstream-a873b292840848b67addb5be0c762d292bde33a1.zip
ipq40xx: add support for Linksys EA6350v3
Specifications: SOC: Qualcomm IPQ4018 RAM: 256 MiB Samsung K4B2G1646F-BYK0 FLASH1: MX25L1605D 2 MB FLASH2: Winbond W25N01GV 128Mb ETH: Qualcomm QCA8075 WLAN0: Qualcomm Atheros QCA4018 2.4GHz 802.11b/g/n 2x2 WLAN1: Qualcomm Atheros QCA4018 5GHz 802.11n/ac W2 2x2 INPUT: WPS, Reset LED: Status - Green SERIAL: Header at J19, Beneath DC Power Jack 1-VCC ; 2-TX ; 3-RX; 4-GND; Serial 115200-8-N-1. Tested and working: - USB (requires extra packages) - LAN Ethernet (Correct MAC-address) - WAN Ethernet (Correct MAC-address) - 2.4 GHz WiFi (Correct MAC-address) - 5 GHz WiFi (Correct MAC-address) - Factory installation from Web UI - OpenWRT sysupgrade - LED - Reset Button Need Testing: - WPS button Install via Web UI: - Attach to a LAN port on the router. - Connect to the Linksys Smart WiFi Page (default 192.168.1.1) and login - Select the connectivity tab on the left - In the manual update box on the right - Select browse, and browse to openwrt-ipq40xx-linksys_ea6350v3-squashfs-factory.bin - Click update. - Read and accept the warning - The router LED will start blinking. When the router LED goes solid, you can now navigate to 192.168.1.1 to your new OpenWrt installation. Sysupgrade: - Flash the sysupgrade image as usual. Please: try to do a reset everytime you can (doing it with LuCI is easy and can be done in the same step). Recovery (Automatic): - If the device fails to boot after install or upgrade, whilst the unit is turned on: 1 - Wait 15 seconds 2 - Switch Off and Wait 10 seconds 3 - Switch on 4 - Repeat steps 1 to 3, 3 times then go to 5. 5 - U-boot will have now erased the failed update and switched back to the last working firmware - you should be able to access your router on LAN. Recovery (Manual): - The steps for manual recovery are the same as the generic u-boot tftp client method. Back To Stock: - Use the generic recovery using the tftp client method to flash the "civic.img". Also you can strip-and-pad the original image and use the generic "mtd" method by flashing over the "kernel" partition. * Just be careful to flash in the partition that the device is currently booted. Signed-off-by: Ryan Pannell <ryan@osukl.com> Signed-off-by: Oever González <notengobattery@gmail.com> [minor edits, removed second compatible of nand, added dtb entry to 4.19] Signed-off-by: Christian Lamparter <chunkeey@gmail.com>
Diffstat (limited to 'target/linux/ipq40xx/base-files')
-rwxr-xr-xtarget/linux/ipq40xx/base-files/etc/board.d/02_network9
-rw-r--r--target/linux/ipq40xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata2
-rwxr-xr-xtarget/linux/ipq40xx/base-files/etc/init.d/zlinksys_recovery34
-rwxr-xr-xtarget/linux/ipq40xx/base-files/lib/upgrade/linksys.sh95
-rw-r--r--target/linux/ipq40xx/base-files/lib/upgrade/platform.sh3
5 files changed, 143 insertions, 0 deletions
diff --git a/target/linux/ipq40xx/base-files/etc/board.d/02_network b/target/linux/ipq40xx/base-files/etc/board.d/02_network
index d73914c7c1..7b9719848e 100755
--- a/target/linux/ipq40xx/base-files/etc/board.d/02_network
+++ b/target/linux/ipq40xx/base-files/etc/board.d/02_network
@@ -45,6 +45,15 @@ glinet,gl-b1300)
ucidef_add_switch "switch0" \
"0u@eth0" "3:lan" "4:lan"
;;
+linksys,ea6350v3)
+ wan_mac_addr=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+ lan_mac_addr=$(macaddr_add $(mtd_get_mac_ascii devinfo hw_mac_addr) +1)
+ ucidef_set_interfaces_lan_wan "eth0" "eth1"
+ ucidef_add_switch "switch0" \
+ "0u@eth0" "1:lan" "2:lan" "3:lan" "4:lan"
+ ucidef_set_interface_macaddr "wan" "$wan_mac_addr"
+ ucidef_set_interface_macaddr "lan" "$lan_mac_addr"
+ ;;
openmesh,a42 |\
openmesh,a62)
ucidef_set_interfaces_lan_wan "eth1" "eth0"
diff --git a/target/linux/ipq40xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/ipq40xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
index 8242fe0eb1..69b6c2591c 100644
--- a/target/linux/ipq40xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
+++ b/target/linux/ipq40xx/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
@@ -115,6 +115,7 @@ case "$FIRMWARE" in
case "$board" in
8dev,jalapeno |\
glinet,gl-b1300 |\
+ linksys,ea6350v3 |\
qcom,ap-dk01.1-c1)
ath10kcal_extract "ART" 4096 12064
;;
@@ -152,6 +153,7 @@ case "$FIRMWARE" in
case "$board" in
8dev,jalapeno |\
glinet,gl-b1300 |\
+ linksys,ea6350v3 |\
qcom,ap-dk01.1-c1)
ath10kcal_extract "ART" 20480 12064
;;
diff --git a/target/linux/ipq40xx/base-files/etc/init.d/zlinksys_recovery b/target/linux/ipq40xx/base-files/etc/init.d/zlinksys_recovery
new file mode 100755
index 0000000000..ac6533e3fe
--- /dev/null
+++ b/target/linux/ipq40xx/base-files/etc/init.d/zlinksys_recovery
@@ -0,0 +1,34 @@
+#!/bin/sh /etc/rc.common
+#
+# This script sets auto_recovery to "yes" and resets the boot counter to 0.
+# As a golden rule, this should be the latest script to run at boot. For a
+# developer snapshot, it is fine to set auto_recovery here. But for a stable
+# release, this script must in fact turn off auto_recovery.
+#
+# Why? Because the custom sysupgrade script for the device will turn on
+# auto_recovery to "yes". And it's the job of this script to set the
+# boot boot_count to 0 and then disable auto_recovery, as that condition
+# means that the stable release went well.
+#
+# I have to repeat: this script should be changed for stable releases.
+
+START=99
+boot() {
+ . /lib/functions.sh
+
+ case $(board_name) in
+ linksys,ea6350v3)
+ # make sure auto_recovery in uboot is always on
+ IS_AUTO_RECOVERY="$(fw_printenv -n auto_recovery)"
+ if [ "$IS_AUTO_RECOVERY" != "yes" ] ; then
+ fw_setenv auto_recovery yes
+ echo "Linksys EA6350v3: fw_setenv: auto_recovery has been set to yes"
+ fi
+ # reset the boot counter
+ fw_setenv boot_count 0
+ mtd resetbc s_env
+ echo "Linksys EA6350v3: boot counter has been reset"
+ echo "Linksys EA6350v3: boot_part=$(fw_printenv -n boot_part)"
+ ;;
+ esac
+}
diff --git a/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
new file mode 100755
index 0000000000..9772d68f3d
--- /dev/null
+++ b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
@@ -0,0 +1,95 @@
+linksys_get_target_firmware() {
+ cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
+ target_firmware=""
+ if [ "$cur_boot_part" = "1" ]; then
+ # current primary boot - update alt boot
+ target_firmware="alt_kernel"
+ fw_setenv boot_part 2
+ # In the Linksys EA6350v3, it is enough to set the boot_part as the boot command line is
+ # bootcmd=if test $boot_part = 1; then run bootpart1; else run bootpart2; fi
+ # - You probably want to use that if your device's uboot does not eval bootcmd
+ #fw_setenv bootcmd "run altnandboot"
+ elif [ "$cur_boot_part" = "2" ]; then
+ # current alt boot - update primary boot
+ target_firmware="kernel"
+ fw_setenv boot_part 1
+ #fw_setenv bootcmd "run nandboot"
+ fi
+
+ # re-enable recovery so we get back if the new firmware is broken
+ fw_setenv auto_recovery yes
+ # see /etc/init.d/zlinksys_recovery
+
+ echo "$target_firmware"
+}
+
+linksys_get_root_magic() {
+ (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+ local magic_long="$(get_magic_long "$1")"
+
+ mkdir -p /var/lock
+ local part_label="$(linksys_get_target_firmware)"
+ touch /var/lock/fw_printenv.lock
+
+ if [ ! -n "$part_label" ]; then
+ echo "cannot find target partition"
+ exit 1
+ fi
+
+ local target_mtd=$(find_mtd_part $part_label)
+
+ [ "$magic_long" = "73797375" ] && {
+ CI_KERNPART="$part_label"
+ if [ "$part_label" = "kernel" ]; then
+ CI_UBIPART="rootfs"
+ else
+ CI_UBIPART="alt_rootfs"
+ fi
+
+ # remove "squashfs" vol (in case we are flashing over a stock image, which is also UBI)
+
+ local mtdnum="$( find_mtd_index "$CI_UBIPART" )"
+ if [ ! "$mtdnum" ]; then
+ echo "cannot find ubi mtd partition $CI_UBIPART"
+ return 1
+ fi
+
+ local ubidev="$( nand_find_ubi "$CI_UBIPART" )"
+ if [ ! "$ubidev" ]; then
+ ubiattach -m "$mtdnum"
+ sync
+ ubidev="$( nand_find_ubi "$CI_UBIPART" )"
+ fi
+
+ if [ "$ubidev" ]; then
+ local squash_ubivol="$( nand_find_volume $ubidev squashfs )"
+ # kill volume
+ [ "$squash_ubivol" ] && ubirmvol /dev/$ubidev -N squashfs || true
+ fi
+
+ # complete std upgrade
+ nand_upgrade_tar "$1"
+ }
+ [ "$magic_long" = "27051956" ] && {
+ # This magic is for a uImage (which is a sysupgrade image)
+ # check firmwares' rootfs types
+ local oldroot="$(linksys_get_root_magic $target_mtd)"
+ local newroot="$(linksys_get_root_magic "$1")"
+
+ if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]; then
+ # we're upgrading from a firmware with UBI to one with UBI
+ # erase everything to be safe
+ # - Is that really needed? Won't remove (or comment) the if, because it may be needed in a future device.
+ #mtd erase $part_label
+ #get_image "$1" | mtd -n write - $part_label
+ echo "writing \"$1\" UBI image to \"$part_label\" (UBI)..."
+ get_image "$1" | mtd write - $part_label
+ else
+ echo "writing \"$1\" image to \"$part_label\""
+ get_image "$1" | mtd write - $part_label
+ fi
+ }
+}
diff --git a/target/linux/ipq40xx/base-files/lib/upgrade/platform.sh b/target/linux/ipq40xx/base-files/lib/upgrade/platform.sh
index 610f9bbbdb..c5f06ffb3a 100644
--- a/target/linux/ipq40xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ipq40xx/base-files/lib/upgrade/platform.sh
@@ -54,6 +54,9 @@ platform_do_upgrade() {
CI_KERNPART="linux"
nand_do_upgrade "$1"
;;
+ linksys,ea6350v3)
+ platform_do_upgrade_linksys "$ARGV"
+ ;;
openmesh,a42 |\
openmesh,a62)
PART_NAME="inactive"